=== debian/changelog ===
docker.io (17.12.1-0ubuntu1) bionic; urgency=medium

  [ Tianon Gravi ]
  * Update to 17.12.1-ce upstream release
    - swap from github.com/docker/docker to .../docker/docker-ce
    - build separate components in a way that can be parallelized
    - remove older (unsupported) contrib/ bits from being shipped
    - drop a lot of unnecessary packaging bits from debian/
  * Adjust debconf prompt:
    - ask during _every_ upgrade
    - default to not restarting

  [ Michael Hudson-Doyle ]
  * Switch to building with default version of Go.
  * Adjust debconf template to match change in behavior.

 -- Tianon Gravi <tianon@debian.org>  Wed, 28 Feb 2018 09:46:05 -0800

docker.io (17.03.2-0ubuntu5) bionic; urgency=medium

  * d/control, d/rules: Fix FTBFS when built with golang 1.10 by build
    depending on golang-1.9-go. See https://github.com/moby/moby/pull/35739
    for upstream discussion on golang 1.10 compatibility.

 -- Tyler Hicks <tyhicks@canonical.com>  Tue, 20 Mar 2018 13:57:16 +0000

docker.io (17.03.2-0ubuntu4) bionic; urgency=medium

  * d/tests/docker-in-lxd: Fix failing test due to /etc/resolv.conf being a
    symlink in Bionic. The 'lxc file pull <path> -' command prints the symlink
    contents (the target path) to stdout, rather than the contents of the
    target file, so use 'lxc exec' to grep /etc/resolv.conf. Grep will follow
    the symlink in situations where /etc/resolv.conf is a symlink.

 -- Tyler Hicks <tyhicks@canonical.com>  Mon, 19 Mar 2018 19:35:52 +0000

docker.io (17.03.2-0ubuntu3) bionic; urgency=medium

  * d/tests/docker-in-lxd: set DEBIAN_FRONTEND=noninteractive when installing
    docker in the lxd container 

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Wed, 21 Feb 2018 10:49:58 +1300

docker.io (17.03.2-0ubuntu2) bionic; urgency=medium

  * Replace "--no-restart-on-upgrade" with "--no-start" and a debconf prompt
    - not restarting Docker causes many issues (LP: #1658691)
    - suggested methods for keeping containers up are to use a restart policy
      ("--restart=..." on "docker run"), Swarm Mode services, or rolling
      replacement of k8s workers
  * Backport 30519 for bashism (LP: #1744599)
    - https://github.com/docker/docker/pull/30519

 -- Tianon Gravi <tianon@debian.org>  Thu, 07 Dec 2017 09:42:53 -0800
